/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("@tensorflow/tfjs-core"),require("seedrandom")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","seedrandom"],e):e((t=t||self).tf=t.tf||{},t.tf,t.seedrandom)}(this,(function(t,e,r){"use strict";var a=function(t,e){return(a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])})(t,e)};function n(t,e,r,a){return new(r||(r=Promise))((function(n,o){function i(t){try{d(a.next(t))}catch(t){o(t)}}function s(t){try{d(a.throw(t))}catch(t){o(t)}}function d(t){var e;t.done?n(t.value):(e=t.value,e instanceof r?e:new r((function(t){t(e)}))).then(i,s)}d((a=a.apply(t,e||[])).next())}))}function o(t,e){var r,a,n,o,i={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(r)throw new TypeError("Generator is already executing.");for(;i;)try{if(r=1,a&&(n=2&o[0]?a.return:o[0]?a.throw||((n=a.return)&&n.call(a),0):a.next)&&!(n=n.call(a,o[1])).done)return n;switch(a=0,n&&(o=[2&o[0],n.value]),o[0]){case 0:case 1:n=o;break;case 4:return i.label++,{value:o[1],done:!1};case 5:i.label++,a=o[1],o=[0];continue;case 7:o=i.ops.pop(),i.trys.pop();continue;default:if(!(n=i.trys,(n=n.length>0&&n[n.length-1])||6!==o[0]&&2!==o[0])){i=0;continue}if(3===o[0]&&(!n||o[1]>n[0]&&o[1]<n[3])){i.label=o[1];break}if(6===o[0]&&i.label<n[1]){i.label=n[1],n=o;break}if(n&&i.label<n[2]){i.label=n[2],i.ops.push(o);break}n[2]&&i.ops.pop(),i.trys.pop();continue}o=e.call(t,i)}catch(t){o=[6,t],a=0}finally{r=n=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}}function i(t,r){Array.isArray(t)||(t=[t]),t.forEach((function(t){null!=t&&e.util.assert("complex64"!==t.dtype,(function(){return r+" does not support complex64 tensors."}))}))}function s(t,r,a,n,o,i){for(var s=o.strideHeight,d=o.strideWidth,h=o.dilationHeight,p=o.dilationWidth,u=o.effectiveFilterHeight,f=o.effectiveFilterWidth,l=o.padInfo.top,c=o.padInfo.left,v="max"===i?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,y=e.buffer(o.outShape,a),m=y.values,g=o.outShape[1]*o.outShape[2]*o.outShape[3],S=o.outShape[2]*o.outShape[3],I=o.outShape[3],b=0;b<o.batchSize;++b)for(var k=b*g,M=b*n[0],x=0;x<o.inChannels;++x)for(var F=0;F<o.outHeight;++F)for(var w=F*s-l,A=Math.max(0,w),z=Math.min(o.inHeight,u+w),T=k+F*S,D=0;D<o.outWidth;++D){for(var W=D*d-c,_=Math.max(0,W),O=Math.min(o.inWidth,f+W),H=v,N=0,B=0,C=A;C<z;C+=h){for(var E=M+C*n[1],P=_;P<O;P+=p){var R=t[E+P*n[2]+x];"max"===i&&R>H?H=R:"avg"===i&&(N+=R,B++)}if(isNaN(H))break}m[T+D*I+x]="avg"===i?N/B:H}return y}function d(t,r,a,n,o,i){void 0===o&&(o=!1),void 0===i&&(i=!1);for(var s=e.buffer(n.outShape,"int32"),d=n.strideHeight,h=n.strideWidth,p=n.dilationHeight,u=n.dilationWidth,f=n.effectiveFilterHeight,l=n.effectiveFilterWidth,c=n.padInfo.top,v=n.padInfo.left,y=e.buffer(r,a,t),m=0;m<n.batchSize;++m)for(var g=0;g<n.inChannels;++g)for(var S=0;S<n.outHeight;++S){for(var I=S*d-c,b=I;b<0;)b+=p;for(var k=Math.min(n.inHeight,f+I),M=0;M<n.outWidth;++M){for(var x=M*h-v,F=x;F<0;)F+=u;for(var w=Math.min(n.inWidth,l+x),A=Number.NEGATIVE_INFINITY,z=-1,T=b;T<k;T+=p)for(var D=T-I,W=F;W<w;W+=u){var _=W-x,O=y.get(m,T,W,g);O>A&&(A=O,z=o?i?((m*n.inHeight+T)*n.inWidth+W)*n.inChannels+g:(T*n.inWidth+W)*n.inChannels+g:D*l+_)}s.set(z,m,S,M,g)}}return s}var h=e.kernel_impls.nonMaxSuppressionV3,p=e.kernel_impls.split,u=e.kernel_impls.tile,f=e.kernel_impls.topkImpl,l=e.kernel_impls.whereImpl;function c(t,e,r,a){if("linear"===r)return t.linear(e);if("relu"===r)return t.relu(e);if("elu"===r)return t.elu(e);if("relu6"===r)return t.relu6(e);if("prelu"===r)return t.prelu(e,a);throw new Error("Activation "+r+" has not been implemented for the CPU backend.")}var v=function(t){function v(){var r=t.call(this)||this;return r.blockSize=48,r.firstUse=!0,r.data=new e.DataStorage(r,e.engine()),r}return function(t,e){function r(){this.constructor=t}a(t,e),t.prototype=null===e?Object.create(e):(r.prototype=e.prototype,new r)}(v,t),v.prototype.write=function(t,r,a){this.firstUse&&(this.firstUse=!1,e.env().get("IS_NODE")&&e.backend_util.warn("\n============================\nHi there 👋. Looks like you are running TensorFlow.js in Node.js. To speed things up dramatically, install our node backend, which binds to TensorFlow C++, by running npm i @tensorflow/tfjs-node, or npm i @tensorflow/tfjs-node-gpu if you have CUDA. Then call require('@tensorflow/tfjs-node'); (-gpu suffix for CUDA) at the start of your program. Visit https://github.com/tensorflow/tfjs-node for more details.\n============================"));var n={};return this.data.set(n,{values:t,dtype:a}),n},v.prototype.move=function(t,e,r,a){this.data.set(t,{values:e,dtype:a})},v.prototype.numDataIds=function(){return this.data.numDataIds()},v.prototype.read=function(t){return n(this,void 0,void 0,(function(){return o(this,(function(e){return[2,this.readSync(t)]}))}))},v.prototype.readSync=function(t){var r=this.data.get(t),a=r.dtype,n=r.complexTensors;if("complex64"===a){var o=this.readSync(n.real.dataId),i=this.readSync(n.imag.dataId);return e.backend_util.mergeRealAndImagArrays(o,i)}return this.data.get(t).values},v.prototype.bufferSync=function(t){var r=this.readSync(t.dataId),a=r;if("string"===t.dtype)try{a=r.map((function(t){return e.util.decodeString(t)}))}catch(t){throw new Error("Failed to decode encoded string bytes into utf-8")}return e.buffer(t.shape,t.dtype,a)},v.prototype.makeOutput=function(t,r,a){var n=this.write(t,r,a);return e.engine().makeTensorFromDataId(n,r,a,this)},v.prototype.disposeData=function(t){if(this.data.has(t)){var e=this.data.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.data.delete(t)}},v.prototype.time=function(t){return n(this,void 0,void 0,(function(){var r;return o(this,(function(a){return r=e.util.now(),t(),[2,{kernelMs:e.util.now()-r}]}))}))},v.prototype.memory=function(){return{unreliable:!0,reasons:["The reported memory is an upper bound. Due to automatic garbage collection, the true allocated memory may be less."]}},v.prototype.complex=function(t,r){var a=this.makeOutput(null,t.shape,"complex64");return this.data.get(a.dataId).complexTensors={real:e.engine().keep(t.clone()),imag:e.engine().keep(r.clone())},a},v.prototype.real=function(t){return this.data.get(t.dataId).complexTensors.real.clone()},v.prototype.imag=function(t){return this.data.get(t.dataId).complexTensors.imag.clone()},v.prototype.slice=function(t,r,a){if(i(t,"slice"),e.slice_util.isSliceContinous(t.shape,r,a)){var n=e.slice_util.computeFlatOffset(r,t.strides),o=e.util.sizeFromShape(a),s=this.readSync(t.dataId);return e.tensor(s.subarray(n,n+o),a,t.dtype)}for(var d=e.buffer(a,t.dtype),h=this.bufferSync(t),p=0;p<d.size;++p){var u=d.indexToLoc(p).map((function(t,e){return t+r[e]}));d.values[p]=h.get.apply(h,u)}return d.toTensor()},v.prototype.stridedSlice=function(t,r,a,n){i(t,"stridedSlice");var o=e.slice_util.computeOutShape(r,a,n);if(o.some((function(t){return 0===t})))return e.tensor([],o);for(var s=e.buffer(o,t.dtype),d=this.bufferSync(t),h=0;h<s.size;h++){for(var p=s.indexToLoc(h),u=new Array(p.length),f=0;f<u.length;f++)u[f]=p[f]*n[f]+r[f];s.set.apply(s,[d.get.apply(d,u)].concat(p))}return s.toTensor()},v.prototype.diag=function(t){for(var r=this.readSync(t.dataId),a=e.buffer([t.size,t.size],t.dtype),n=a.values,o=0;o<r.length;o++)n[o*t.size+o]=r[o];return a.toTensor()},v.prototype.unstack=function(t,e){for(var r=t.shape[e],a=new Array(t.rank-1),n=0,o=0;o<t.rank;o++)o!==e&&(a[n++]=t.shape[o]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var d=new Array(r);for(o=0;o<d.length;o++)i[e]=o,d[o]=this.slice(t,i,s).reshape(a);return d},v.prototype.reverse=function(t,r){i(t,"reverse");for(var a=e.buffer(t.shape,t.dtype),n=this.bufferSync(t),o=function(e){var o=a.indexToLoc(e),i=o.slice();r.forEach((function(e){return i[e]=t.shape[e]-1-i[e]})),a.set.apply(a,[n.get.apply(n,i)].concat(o))},s=0;s<a.size;s++)o(s);return a.toTensor()},v.prototype.concat=function(t,r){var a=this;if("complex64"===t[0].dtype){var n=t.map((function(t){return e.real(t)})),o=t.map((function(t){return e.imag(t)}));return e.complex(this.concat(n,r),this.concat(o,r))}var i=t.map((function(t){var a=e.util.sizeFromShape(t.shape.slice(r));return t.as2D(-1,a)})),s=e.backend_util.computeOutShape(i.map((function(t){return t.shape})),1),d=e.buffer(s,t[0].dtype).values;if(1===i[0].shape[0]){var h=0;i.forEach((function(t){d.set(a.readSync(t.dataId),h),h+=t.size}))}else{var p=0;i.forEach((function(t){for(var e=a.readSync(t.dataId),r=0,n=0;n<t.shape[0];++n)for(var o=n*s[1]+p,i=0;i<t.shape[1];++i)d[o+i]=e[r++];p+=t.shape[1]}))}var u=e.backend_util.computeOutShape(t.map((function(t){return t.shape})),r);return e.tensor(d,u,t[0].dtype)},v.prototype.neg=function(t){return i(t,"neg"),this.multiply(e.scalar(-1),t)},v.prototype.add=function(t,r){return"complex64"===t.dtype||"complex64"===r.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),r.cast("complex64"),(function(t,e,r,a){return{real:t+r,imag:e+a}})):this.broadcastedBinaryOp(t,r,e.upcastType(t.dtype,r.dtype),(function(t,e){return t+e}))},v.prototype.addN=function(t){var r=this;i(t,"addN");for(var a=t.map((function(t){return r.readSync(t.dataId)})),n=e.buffer(t[0].shape,t[0].dtype),o=n.values,s=0;s<t.length;s++)for(var d=a[s],h=0;h<o.length;h++)o[h]+=d[h];return n.toTensor()},v.prototype.softmax=function(t,r){var a=e.util.parseAxisParam([r],t.shape),n=this.max(t,a),o=e.backend_util.expandShapeToKeepDim(n.shape,a),i=this.subtract(t,n.reshape(o)),s=this.exp(i),d=this.sum(s,a).reshape(o);return e.div(s,d)},v.prototype.subtract=function(t,r){return"complex64"===t.dtype||"complex64"===r.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),r.cast("complex64"),(function(t,e,r,a){return{real:t-r,imag:e-a}})):this.broadcastedBinaryOp(t,r,e.upcastType(t.dtype,r.dtype),(function(t,e){return t-e}))},v.prototype.pow=function(t,e){return i([t,e],"pow"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.pow(t,e)}))},v.prototype.batchMatMul=function(t,r,a,n){i([t,r],"matMul");for(var o=a?t.shape[1]:t.shape[2],s=a?t.shape[2]:t.shape[1],d=n?r.shape[1]:r.shape[2],h=t.shape[0],p=this.readSync(t.dataId),u=this.readSync(r.dataId),f=a?[t.strides[0],1,t.strides[1]]:[t.strides[0],t.strides[1],1],l=f[0],c=f[1],v=f[2],y=n?[1,r.strides[1],r.strides[0]]:[r.strides[1],1,r.strides[0]],m=y[0],g=y[1],S=y[2],I=s*d,b=e.buffer([h,s,d],t.dtype),k=b.values,M=this.blockSize,x=0;x<h;x++)for(var F=0;F<s;F+=M)for(var w=0;w<d;w+=M)for(var A=0;A<o;A+=M)for(var z=Math.min(F+M,s),T=Math.min(w+M,d),D=Math.min(A+M,o),W=F;W<z;W++)for(var _=w;_<T;_++){for(var O=0,H=A;H<D;H++)O+=p[x*l+W*c+H*v]*u[H*m+_*g+x*S];k[x*I+(W*d+_)]+=O}return b.toTensor()},v.prototype.fusedBatchMatMul=function(t){var e=t.a,r=t.b,a=t.transposeA,n=t.transposeB,o=t.bias,i=t.activation,s=t.preluActivationWeights,d=this.batchMatMul(e,r,a,n);return o&&(d=this.add(d,o)),i&&(d=c(this,d,i,s)),d},v.prototype.multiply=function(t,r){return"complex64"===t.dtype||"complex64"===r.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),r.cast("complex64"),(function(t,e,r,a){return{real:t*r-e*a,imag:t*a+e*r}})):this.broadcastedBinaryOp(t,r,e.upcastType(t.dtype,r.dtype),(function(t,e){return t*e}))},v.prototype.floorDiv=function(t,e){i([t,e],"floorDiv");return this.broadcastedBinaryOp(t,e,"int32",(function(t,e){return Math.floor(t/e)}))},v.prototype.sum=function(t,r){i(t,"sum"),e.backend_util.assertAxesAreInnerMostDims("sum",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],s=e.upcastType(t.dtype,"int32"),d=e.zeros(n,s),h=e.util.sizeFromShape(o),p=this.readSync(d.dataId),u=this.readSync(t.dataId),f=0;f<p.length;++f){for(var l=f*h,c=0,v=0;v<h;++v)c+=u[l+v];p[f]=c}return d},v.prototype.prod=function(t,r){i(t,"sum");for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],s=e.upcastType(t.dtype,"int32"),d=e.zeros(n,s),h=e.util.sizeFromShape(o),p=this.readSync(d.dataId),u=this.readSync(t.dataId),f=0;f<p.length;++f){for(var l=f*h,c=1,v=0;v<h;++v)c*=u[l+v];p[f]=c}return d},v.prototype.unsortedSegmentSum=function(t,r,a){i(t,"unsortedSegmentSum");for(var n=[],o=t.rank-r.rank,s=0;s<o;++s)r=r.expandDims(s+1);for(s=0;s<a;++s){var d=e.scalar(s,"int32"),h=e.equal(d,r).asType("float32").mul(t).sum(0);n.push(h)}return e.stack(n)},v.prototype.argMin=function(t,r){i(t,"argMin");var a=[r];e.backend_util.assertAxesAreInnerMostDims("argMin",a,t.rank);for(var n=e.backend_util.computeOutAndReduceShapes(t.shape,a),o=n[0],s=n[1],d=e.zeros(o,"int32"),h=e.util.sizeFromShape(s),p=this.readSync(d.dataId),u=this.readSync(t.dataId),f=0;f<p.length;++f){for(var l=f*h,c=u[l],v=0,y=0;y<h;++y){var m=u[l+y];m<c&&(c=m,v=y)}p[f]=v}return d},v.prototype.argMax=function(t,r){i(t,"argMax");var a=[r];e.backend_util.assertAxesAreInnerMostDims("argMax",a,t.rank);for(var n=e.backend_util.computeOutAndReduceShapes(t.shape,a),o=n[0],s=n[1],d=e.zeros(o,"int32"),h=e.util.sizeFromShape(s),p=this.readSync(d.dataId),u=this.readSync(t.dataId),f=0;f<p.length;++f){for(var l=f*h,c=u[l],v=0,y=0;y<h;++y){var m=u[l+y];m>c&&(c=m,v=y)}p[f]=v}return d},v.prototype.cumsum=function(t,r,a,n){if(i(t,"cumsum"),r!==t.rank-1)throw new Error("backend.cumsum in CPU expects an inner-most axis="+(t.rank-1)+" but got axis="+r);for(var o=e.upcastType(t.dtype,"int32"),s=e.zeros(t.shape,o),d=this.readSync(s.dataId),h=this.readSync(t.dataId),p=t.shape[t.rank-1],u=n?function(t,e){return t+p-e-1}:function(t,e){return t+e},f=0;f<h.length;f+=p)for(var l=0;l<p;l++){var c=u(f,l);if(0===l)d[c]=a?0:h[c];else{var v=u(f,l-1);d[c]=a?h[v]+d[v]:h[c]+d[v]}}return s},v.prototype.equal=function(t,e){return i([t,e],"equal"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t===e?1:0}))},v.prototype.notEqual=function(t,e){return i([t,e],"notEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t!==e?1:0}))},v.prototype.less=function(t,e){return i([t,e],"less"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t<e?1:0}))},v.prototype.lessEqual=function(t,e){return i([t,e],"lessEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t<=e?1:0}))},v.prototype.greater=function(t,e){return i([t,e],"greater"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t>e?1:0}))},v.prototype.greaterEqual=function(t,e){return i([t,e],"greaterEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t>=e?1:0}))},v.prototype.logicalNot=function(t){i(t,"logicalNot");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)r[a]=e[a]?0:1;return this.makeOutput(r,t.shape,"bool")},v.prototype.logicalAnd=function(t,e){return i([t,e],"logicalAnd"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t&&e}))},v.prototype.logicalOr=function(t,e){return i([t,e],"logicalOr"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t||e}))},v.prototype.select=function(t,r,a){i([t,r,a],"select");for(var n=this.readSync(t.dataId),o=this.readSync(r.dataId),s=this.readSync(a.dataId),d=e.zeros(r.shape,e.upcastType(r.dtype,a.dtype)),h=this.readSync(d.dataId),p=0,u=0===t.rank||t.rank>1||1===r.rank?1:e.util.sizeFromShape(r.shape.slice(1)),f=0;f<n.length;f++)for(var l=0;l<u;l++)1===n[f]?h[p++]=o[f]:h[p++]=s[f];return d},v.prototype.where=function(t){i([t],"where");var e=this.readSync(t.dataId);return l(t.shape,e)},v.prototype.topk=function(t,e,r){i(t,"topk");var a=this.readSync(t.dataId);return f(a,t.shape,t.dtype,e,r)},v.prototype.min=function(t,r){i(t,"min"),e.backend_util.assertAxesAreInnerMostDims("min",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],s=e.zeros(n,t.dtype),d=e.util.sizeFromShape(o),h=this.readSync(s.dataId),p=this.readSync(t.dataId),u=0;u<h.length;++u){for(var f=u*d,l=p[f],c=0;c<d;++c){var v=p[f+c];v<l&&(l=v)}h[u]=l}return s},v.prototype.minimum=function(t,e){return i([t,e],"minimum"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.min(t,e)}))},v.prototype.mod=function(t,e){return i([t,e],"mod"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var r=t%e;return t<0&&e<0||t>=0&&e>=0?r:(r+e)%e}))},v.prototype.max=function(t,r){i(t,"max"),e.backend_util.assertAxesAreInnerMostDims("max",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],s=e.zeros(n,t.dtype),d=e.util.sizeFromShape(o),h=this.readSync(s.dataId),p=this.readSync(t.dataId),u=0;u<h.length;++u){for(var f=u*d,l=p[f],c=0;c<d;++c){var v=p[f+c];v>l&&(l=v)}h[u]=l}return s},v.prototype.maximum=function(t,e){return i([t,e],"maximum"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.max(t,e)}))},v.prototype.all=function(t,r){i(t,"all"),e.backend_util.assertAxesAreInnerMostDims("all",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],s=e.zeros(n,t.dtype),d=e.util.sizeFromShape(o),h=this.readSync(s.dataId),p=this.readSync(t.dataId),u=0;u<h.length;++u){for(var f=u*d,l=p[f],c=0;c<d;++c){var v=p[f+c];l=l&&v}h[u]=l}return s},v.prototype.any=function(t,r){i(t,"any"),e.backend_util.assertAxesAreInnerMostDims("any",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],s=e.zeros(n,t.dtype),d=e.util.sizeFromShape(o),h=this.readSync(s.dataId),p=this.readSync(t.dataId),u=0;u<h.length;++u){for(var f=u*d,l=p[f],c=0;c<d;++c){var v=p[f+c];l=l||v}h[u]=l}return s},v.prototype.squaredDifference=function(t,e){return i([t,e],"squaredDifference"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var r=t-e;return r*r}))},v.prototype.ceil=function(t){i(t,"ceil");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.ceil(e[a]);return this.makeOutput(r,t.shape,"float32")},v.prototype.floor=function(t){i(t,"floor");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.floor(e[a]);return this.makeOutput(r,t.shape,"float32")},v.prototype.sign=function(t){i(t,"x");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)e[a]<0?r[a]=-1:e[a]>0?r[a]=1:r[a]=0;return this.makeOutput(r,t.shape,"float32")},v.prototype.isNaN=function(t){i(t,"x");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)Number.isNaN(e[a])&&(r[a]=1);return this.makeOutput(r,t.shape,"bool")},v.prototype.isInf=function(t){i(t,"x");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)Math.abs(e[a])===1/0&&(r[a]=1);return this.makeOutput(r,t.shape,"bool")},v.prototype.isFinite=function(t){i(t,"x");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)Number.isFinite(e[a])&&(r[a]=1);return this.makeOutput(r,t.shape,"bool")},v.prototype.round=function(t){i(t,"round");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=Math.floor(e[a]);e[a]-n<.5?r[a]=Math.floor(e[a]):e[a]-n>.5?r[a]=Math.ceil(e[a]):r[a]=n%2==0?n:n+1}return this.makeOutput(r,t.shape,"float32")},v.prototype.exp=function(t){i(t,"exp");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.exp(e[a]);return this.makeOutput(r,t.shape,"float32")},v.prototype.expm1=function(t){i(t,"expm1");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.expm1(e[a]);return this.makeOutput(r,t.shape,"float32")},v.prototype.log=function(t){i(t,"log");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=Math.log(n)}return this.makeOutput(r,t.shape,"float32")},v.prototype.log1p=function(t){i(t,"log1p");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=Math.log1p(n)}return this.makeOutput(r,t.shape,"float32")},v.prototype.sqrt=function(t){i(t,"sqrt");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=Math.sqrt(n)}return this.makeOutput(r,t.shape,"float32")},v.prototype.rsqrt=function(t){i(t,"rsqrt");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=1/Math.sqrt(n)}return this.makeOutput(r,t.shape,"float32")},v.prototype.reciprocal=function(t){i(t,"reciprocal");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=1/e[a];return this.makeOutput(r,t.shape,"float32")},v.prototype.linear=function(t){return t},v.prototype.relu=function(t){i(t,"relu");for(var r=e.zeros(t.shape,t.dtype),a=this.readSync(r.dataId),n=this.readSync(t.dataId),o=0;o<n.length;++o)a[o]=Math.max(0,n[o]);return r},v.prototype.relu6=function(t){i(t,"relu");for(var r=e.zeros(t.shape,t.dtype),a=this.readSync(r.dataId),n=this.readSync(t.dataId),o=0;o<n.length;++o)a[o]=Math.min(Math.max(0,n[o]),6);return r},v.prototype.prelu=function(t,e){return i([t,e],"prelu"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return t<0?e*t:t}))},v.prototype.elu=function(t){i(t,"elu");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a){var n=r[a];e[a]=n>=0?n:Math.exp(n)-1}return this.makeOutput(e,t.shape,"float32")},v.prototype.eluDer=function(t,e){i([t,e],"eluDer");for(var r=new Float32Array(e.size),a=this.readSync(e.dataId),n=this.readSync(t.dataId),o=0;o<a.length;++o){var s=a[o];r[o]=s>=1?n[o]:n[o]*(s+1)}return this.makeOutput(r,e.shape,"float32")},v.prototype.selu=function(t){i(t,"selu");for(var r=e.backend_util.SELU_SCALEALPHA,a=e.backend_util.SELU_SCALE,n=new Float32Array(t.size),o=this.readSync(t.dataId),s=0;s<o.length;++s){var d=o[s];n[s]=d>=0?a*d:r*(Math.exp(d)-1)}return this.makeOutput(n,t.shape,"float32")},v.prototype.clip=function(t,e,r){i(t,"clip");for(var a=new Float32Array(t.size),n=this.readSync(t.dataId),o=0;o<n.length;++o){var s=n[o];a[o]=s>r?r:s<e?e:s}return this.makeOutput(a,t.shape,"float32")},v.prototype.abs=function(t){for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.abs(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.complexAbs=function(t){for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<t.size;++a){var n=r[2*a],o=r[2*a+1];e[a]=Math.hypot(n,o)}return this.makeOutput(e,t.shape,"float32")},v.prototype.int=function(t){i(t,"int");for(var e=new Int32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=r[a];return this.makeOutput(e,t.shape,"int32")},v.prototype.sigmoid=function(t){i(t,"sigmoid");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=1/(1+Math.exp(-r[a]));return this.makeOutput(e,t.shape,"float32")},v.prototype.softplus=function(t){i(t,"softplus");for(var e=Math.log(1.1920928955078125e-7)+2,r=new Float32Array(t.size),a=this.readSync(t.dataId),n=0;n<a.length;++n){var o=a[n]>-e,s=a[n]<e,d=Math.exp(a[n]),h=void 0;h=s?d:o?a[n]:Math.log(1+d),r[n]=h}return this.makeOutput(r,t.shape,"float32")},v.prototype.sin=function(t){i(t,"sin");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.sin(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.cos=function(t){i(t,"cos");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.cos(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.tan=function(t){i(t,"tan");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.tan(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.asin=function(t){i(t,"asin");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.asin(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.acos=function(t){i(t,"acos");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.acos(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.atan=function(t){i(t,"atan");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.atan(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.atan2=function(t,e){return i([t,e],"atan2"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.atan2(t,e)}))},v.prototype.sinh=function(t){i(t,"sinh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.sinh(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.cosh=function(t){i(t,"cosh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.cosh(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.tanh=function(t){i(t,"tanh");for(var r=new Float32Array(t.size),a=this.readSync(t.dataId),n=0;n<a.length;++n)r[n]=e.util.tanh(a[n]);return this.makeOutput(r,t.shape,"float32")},v.prototype.asinh=function(t){i(t,"asinh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.asinh(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.acosh=function(t){i(t,"acosh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.acosh(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.atanh=function(t){i(t,"atanh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.atanh(r[a]);return this.makeOutput(e,t.shape,"float32")},v.prototype.erf=function(t){i(t,"erf");for(var r=new Float32Array(t.size),a=this.readSync(t.dataId),n=e.backend_util.ERF_P,o=e.backend_util.ERF_A1,s=e.backend_util.ERF_A2,d=e.backend_util.ERF_A3,h=e.backend_util.ERF_A4,p=e.backend_util.ERF_A5,u=0;u<a.length;++u){var f=Math.sign(a[u]),l=Math.abs(a[u]),c=1/(1+n*l);r[u]=f*(1-((((p*c+h)*c+d)*c+s)*c+o)*c*Math.exp(-l*l))}return this.makeOutput(r,t.shape,"float32")},v.prototype.step=function(t,e){void 0===e&&(e=0),i(t,"step");for(var r=new Float32Array(t.size),a=this.readSync(t.dataId),n=0;n<a.length;++n){var o=a[n];isNaN(o)?r[n]=NaN:r[n]=o>0?1:e}return this.makeOutput(r,t.shape,"float32")},v.prototype.fusedConv2d=function(t){var e=t.input,r=t.filter,a=t.convInfo,n=t.bias,o=t.activation,i=t.preluActivationWeights,s=this.conv2d(e,r,a);return n&&(s=this.add(s,n)),o&&(s=c(this,s,o,i)),s},v.prototype.conv2d=function(t,r,a){i([t,r],"conv2d");for(var n=a.filterHeight,o=a.filterWidth,s=a.dilationHeight,d=a.dilationWidth,h=a.padInfo.left,p=a.padInfo.top,u="channelsLast"===a.dataFormat,f=e.buffer(a.outShape,t.dtype),l=t.strides[0],c=u?t.strides[1]:t.strides[2],v=u?t.strides[2]:1,y=u?1:t.strides[1],m=f.strides[0],g=u?f.strides[1]:f.strides[2],S=u?f.strides[2]:1,I=u?1:f.strides[1],b=this.readSync(t.dataId),k=this.readSync(r.dataId),M=f.values,x=0;x<a.batchSize;++x)for(var F=x*l,w=x*m,A=0;A<a.outHeight;++A)for(var z=w+A*g,T=A*a.strideHeight-p,D=0;D<n;D++){var W=T+D*s;if(!(W<0||W>=a.inHeight))for(var _=D*r.strides[0],O=F+W*c,H=0;H<a.outWidth;++H)for(var N=z+H*S,B=H*a.strideWidth-h,C=0;C<o;C++){var E=B+C*d;if(!(E<0||E>=a.inWidth))for(var P=O+E*v,R=_+C*r.strides[1],q=0;q<a.inChannels;++q){for(var L=b[P+q*y],U=0;U<a.outChannels;++U)M[N+U*I]+=L*k[R+U];R+=a.outChannels}}}return f.toTensor()},v.prototype.conv3d=function(t,r,a){for(var n=a.filterDepth,o=a.filterHeight,i=a.filterWidth,s=a.dilationDepth,d=a.dilationHeight,h=a.dilationWidth,p=a.padInfo.front,u=a.padInfo.left,f=a.padInfo.top,l=e.buffer(a.outShape,t.dtype),c=this.readSync(t.dataId),v=this.readSync(r.dataId),y=l.values,m=0;m<a.batchSize;++m)for(var g=m*t.strides[0],S=m*l.strides[0],I=0;I<a.outDepth;++I)for(var b=S+I*l.strides[1],k=I*a.strideDepth-p,M=0;M<n;M++){var x=k+M*s;if(!(x<0||x>=a.inDepth))for(var F=M*r.strides[0],w=g+x*t.strides[1],A=0;A<a.outHeight;++A)for(var z=b+A*l.strides[2],T=A*a.strideHeight-f,D=0;D<o;D++){var W=T+D*d;if(!(W<0||W>=a.inHeight))for(var _=F+D*r.strides[1],O=w+W*t.strides[2],H=0;H<a.outWidth;++H)for(var N=z+H*a.outChannels,B=H*a.strideWidth-u,C=0;C<i;C++){var E=B+C*h;if(!(E<0||E>=a.inWidth))for(var P=_+C*r.strides[2],R=O+E*a.inChannels,q=P,L=0;L<a.inChannels;++L){for(var U=c[R+L],j=0;j<a.outChannels;++j)y[N+j]+=U*v[q+j];q+=a.outChannels}}}}return l.toTensor()},v.prototype.conv2dDerInput=function(t,r,a){i([t,r],"conv2dDerInput");for(var n=e.buffer(a.inShape,"float32"),o=n.values,s=this.readSync(t.dataId),d=this.readSync(r.dataId),h=r.strides,p=h[0],u=h[1],f=h[2],l=a.batchSize,c=a.filterHeight,v=a.filterWidth,y=a.inChannels,m=a.inHeight,g=a.inWidth,S=a.outChannels,I=a.outHeight,b=a.outWidth,k=a.strideHeight,M=a.strideWidth,x=a.dataFormat,F=c-1-a.padInfo.top,w=v-1-a.padInfo.left,A="channelsLast"===x,z=n.strides[0],T=A?n.strides[1]:n.strides[2],D=A?n.strides[2]:1,W=A?1:n.strides[1],_=t.strides[0],O=A?t.strides[1]:t.strides[2],H=A?t.strides[2]:1,N=A?1:t.strides[1],B=0;B<l;++B)for(var C=0;C<y;++C)for(var E=0;E<m;++E)for(var P=E-F,R=Math.max(0,Math.ceil(P/k)),q=Math.min(I,(c+P)/k),L=0;L<g;++L){for(var U=L-w,j=Math.max(0,Math.ceil(U/M)),G=Math.min(b,(v+U)/M),V=0,Y=R;Y<q;++Y)for(var K=Y*k-P,J=j;J<G;++J)for(var Q=_*B+O*Y+H*J,X=p*(c-1-K)+u*(v-1-(J*M-U))+f*C,Z=0;Z<S;++Z){V+=s[Q+N*Z]*d[X+Z]}o[z*B+T*E+D*L+W*C]=V}return n.toTensor()},v.prototype.conv3dDerInput=function(t,r,a){for(var n=e.buffer(a.inShape,"float32"),o=n.values,i=n.strides,s=i[0],d=i[1],h=i[2],p=i[3],u=this.readSync(t.dataId),f=t.strides,l=f[0],c=f[1],v=f[2],y=f[3],m=this.readSync(r.dataId),g=r.strides,S=g[0],I=g[1],b=g[2],k=g[3],M=a.batchSize,x=a.filterDepth,F=a.filterHeight,w=a.filterWidth,A=a.inChannels,z=a.inDepth,T=a.inHeight,D=a.inWidth,W=a.outChannels,_=a.outDepth,O=a.outHeight,H=a.outWidth,N=a.strideDepth,B=a.strideHeight,C=a.strideWidth,E=x-1-a.padInfo.front,P=F-1-a.padInfo.top,R=w-1-a.padInfo.left,q=0;q<M;++q)for(var L=0;L<A;++L)for(var U=0;U<z;++U)for(var j=U-E,G=Math.max(0,Math.ceil(j/N)),V=Math.min(_,(x+j)/N),Y=0;Y<T;++Y)for(var K=Y-P,J=Math.max(0,Math.ceil(K/B)),Q=Math.min(O,(F+K)/B),X=0;X<D;++X){for(var Z=X-R,$=Math.max(0,Math.ceil(Z/C)),tt=Math.min(H,(w+Z)/C),et=0,rt=G;rt<V;++rt)for(var at=rt*N-j,nt=J;nt<Q;++nt)for(var ot=nt*B-K,it=$;it<tt;++it)for(var st=l*q+c*rt+v*nt+y*it,dt=S*(x-1-at)+I*(F-1-ot)+b*(w-1-(it*C-Z))+k*L,ht=0;ht<W;++ht){et+=u[st+ht]*m[dt+ht]}o[s*q+d*U+h*Y+p*X+L]=et}return n.toTensor()},v.prototype.conv2dDerFilter=function(t,r,a){i([t,r],"conv2dDerFilter");for(var n=a.strideHeight,o=a.strideWidth,s=a.filterHeight,d=a.filterWidth,h="channelsLast"===a.dataFormat,p=e.buffer(a.filterShape,"float32"),u=a.padInfo.left,f=a.padInfo.top,l=this.bufferSync(t),c=this.bufferSync(r),v=0;v<s;++v)for(var y=Math.max(0,Math.ceil((f-v)/n)),m=Math.min(a.outHeight,(a.inHeight+f-v)/n),g=0;g<d;++g)for(var S=Math.max(0,Math.ceil((u-g)/o)),I=Math.min(a.outWidth,(a.inWidth+u-g)/o),b=0;b<a.inChannels;++b)for(var k=0;k<a.outChannels;++k){for(var M=0,x=0;x<a.batchSize;++x)for(var F=y;F<m;++F)for(var w=v+F*n-f,A=S;A<I;++A){var z=g+A*o-u;M+=h?l.get(x,w,z,b)*c.get(x,F,A,k):l.get(x,b,w,z)*c.get(x,k,F,A)}p.set(M,v,g,b,k)}return p.toTensor()},v.prototype.conv3dDerFilter=function(t,r,a){for(var n=a.strideDepth,o=a.strideHeight,i=a.strideWidth,s=a.filterDepth,d=a.filterHeight,h=a.filterWidth,p=e.buffer(a.filterShape,"float32"),u=p.values,f=p.strides,l=f[0],c=f[1],v=f[2],y=f[3],m=this.readSync(r.dataId),g=r.strides,S=g[0],I=g[1],b=g[2],k=g[3],M=this.readSync(t.dataId),x=t.strides,F=x[0],w=x[1],A=x[2],z=x[3],T=a.padInfo.front,D=a.padInfo.left,W=a.padInfo.top,_=0;_<s;++_)for(var O=Math.max(0,Math.ceil((T-_)/n)),H=Math.min(a.outDepth,(a.inDepth+T-_)/n),N=_*l,B=0;B<d;++B)for(var C=Math.max(0,Math.ceil((W-B)/o)),E=Math.min(a.outHeight,(a.inHeight+W-B)/o),P=B*c+N,R=0;R<h;++R)for(var q=Math.max(0,Math.ceil((D-R)/i)),L=Math.min(a.outWidth,(a.inWidth+D-R)/i),U=R*v+P,j=0;j<a.inChannels;++j)for(var G=j*y+U,V=0;V<a.outChannels;++V){for(var Y=0,K=0;K<a.batchSize;++K)for(var J=K*F,Q=K*S,X=O;X<H;++X)for(var Z=(_+X*n-T)*w+J,$=X*I+Q,tt=C;tt<E;++tt)for(var et=(B+tt*o-W)*A+Z,rt=tt*b+$,at=q;at<L;++at){var nt=at*k+rt;Y+=M[(R+at*i-D)*z+et+j]*m[nt+V]}u[G+V]=Y}return p.toTensor()},v.prototype.fusedDepthwiseConv2D=function(t){var e=t.input,r=t.filter,a=t.convInfo,n=t.bias,o=t.activation,i=t.preluActivationWeights,s=this.depthwiseConv2D(e,r,a);return n&&(s=this.add(s,n)),o&&(s=c(this,s,o,i)),s},v.prototype.depthwiseConv2D=function(t,r,a){i([t,r],"depthwiseConv2D");for(var n=a.filterHeight,o=a.filterWidth,s=a.dilationHeight,d=a.dilationWidth,h=a.padInfo.left,p=a.padInfo.top,u=a.outChannels/a.inChannels,f=e.buffer(a.outShape,t.dtype),l=this.readSync(t.dataId),c=this.readSync(r.dataId),v=f.values,y=0;y<a.batchSize;++y)for(var m=y*t.strides[0],g=y*f.strides[0],S=0;S<a.outHeight;++S)for(var I=g+S*f.strides[1],b=S*a.strideHeight-h,k=0;k<n;++k){var M=b+k*s;if(!(M<0||M>=a.inHeight))for(var x=k*r.strides[0],F=m+M*t.strides[1],w=0;w<a.outWidth;++w)for(var A=I+w*f.strides[2],z=w*a.strideWidth-p,T=0;T<o;++T){var D=z+T*d;if(!(D<0||D>=a.inWidth))for(var W=x+T*r.strides[1],_=F+D*a.inChannels,O=A,H=W,N=0;N<a.inChannels;++N){for(var B=l[_+N],C=0;C<u;++C)v[O+C]+=B*c[H+C];O+=u,H+=u}}}return f.toTensor()},v.prototype.depthwiseConv2DDerInput=function(t,r,a){i([t,r],"depthwiseConv2DDerInput");for(var n=e.buffer(a.inShape,"float32"),o=n.values,s=n.strides,d=s[0],h=s[1],p=s[2],u=this.readSync(t.dataId),f=t.strides,l=f[0],c=f[1],v=f[2],y=this.readSync(r.dataId),m=r.strides,g=m[0],S=m[1],I=m[2],b=a.batchSize,k=a.filterHeight,M=a.filterWidth,x=a.inChannels,F=a.inHeight,w=a.inWidth,A=a.outChannels,z=a.outHeight,T=a.outWidth,D=a.strideHeight,W=a.strideWidth,_=k-1-a.padInfo.top,O=M-1-a.padInfo.left,H=A/x,N=0;N<b;++N)for(var B=0;B<x;++B)for(var C=0;C<F;++C)for(var E=C-_,P=Math.max(0,Math.ceil(E/D)),R=Math.min(z,(k+E)/D),q=0;q<w;++q){for(var L=q-O,U=Math.max(0,Math.ceil(L/W)),j=Math.min(T,(M+L)/W),G=0,V=P;V<R;++V)for(var Y=V*D-E,K=U;K<j;++K)for(var J=l*N+c*V+v*K,Q=g*(k-1-Y)+S*(M-1-(K*W-L))+I*B,X=0;X<H;++X){G+=u[J+(B*H+X)]*y[Q+X]}o[d*N+h*C+p*q+B]=G}return n.toTensor()},v.prototype.depthwiseConv2DDerFilter=function(t,r,a){i([t,r],"depthwiseConv2DDerFilter");for(var n=a.strideHeight,o=a.strideWidth,s=a.filterHeight,d=a.filterWidth,h=e.buffer(a.filterShape,"float32"),p=a.padInfo.left,u=a.padInfo.top,f=a.outChannels/a.inChannels,l=this.bufferSync(t),c=this.bufferSync(r),v=0;v<s;++v)for(var y=Math.max(0,Math.ceil((u-v)/n)),m=Math.min(a.outHeight,(a.inHeight+u-v)/n),g=0;g<d;++g)for(var S=Math.max(0,Math.ceil((p-g)/o)),I=Math.min(a.outWidth,(a.inWidth+p-g)/o),b=0;b<a.outChannels;++b){for(var k=Math.trunc(b/f),M=b%f,x=0,F=0;F<a.batchSize;++F)for(var w=y;w<m;++w)for(var A=v+w*n-u,z=S;z<I;++z){var T=g+z*o-p;x+=l.get(F,A,T,k)*c.get(F,w,z,b)}h.set(x,v,g,k,M)}return h.toTensor()},v.prototype.tile=function(t,e){return i(t,"tile"),u(this.bufferSync(t),e)},v.prototype.pad=function(t,r,a){i(t,"pad");var n=r.map((function(e,r){return e[0]+t.shape[r]+e[1]})),o=r.map((function(t){return t[0]})),s=this.bufferSync(t),d=e.buffer(n,t.dtype);0!==a&&d.values.fill(a);for(var h=0;h<t.size;h++){var p=s.indexToLoc(h),u=p.map((function(t,e){return t+o[e]}));d.set.apply(d,[s.get.apply(s,p)].concat(u))}return d.toTensor()},v.prototype.gather=function(t,r,a){i([t,r],"gather");var n=t.shape.slice(),o=this.readSync(r.dataId);n[a]=o.length;for(var s=e.buffer(n,t.dtype),d=this.bufferSync(t),h=0;h<s.size;++h){var p=s.indexToLoc(h),u=p.slice();u[a]=o[p[a]];var f=d.locToIndex(u);s.values[h]=d.values[f]}return s.toTensor()},v.prototype.batchToSpaceND=function(t,r,a){i([t],"batchToSpaceND");var n=r.reduce((function(t,e){return t*e})),o=e.backend_util.getReshaped(t.shape,r,n),s=e.backend_util.getPermuted(o.length,r.length),d=e.backend_util.getReshapedPermuted(t.shape,r,n),h=e.backend_util.getSliceBeginCoords(a,r.length),p=e.backend_util.getSliceSize(d,a,r.length);return e.transpose(t.reshape(o),s).reshape(d).slice(h,p)},v.prototype.spaceToBatchND=function(t,r,a){i([t],"spaceToBatchND");var n=r.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,a);for(var s=1+r.length;s<t.shape.length;++s)o.push([0,0]);var d=t.pad(o),h=e.backend_util.getReshaped(d.shape,r,n,!1),p=e.backend_util.getPermuted(h.length,r.length,!1),u=e.backend_util.getReshapedPermuted(d.shape,r,n,!1);return e.transpose(d.reshape(h),p).reshape(u)},v.prototype.maxPool=function(t,e){return i(t,"maxPool"),s(this.readSync(t.dataId),t.shape,t.dtype,t.strides,e,"max").toTensor()},v.prototype.maxPoolBackprop=function(t,r,a,n){i([r,a],"maxPoolBackprop");for(var o=this.readSync(r.dataId),s=e.buffer(n.outShape,r.dtype,d(o,r.shape,r.dtype,n).values),h=n.strideHeight,p=n.strideWidth,u=n.dilationHeight,f=n.dilationWidth,l=n.effectiveFilterHeight,c=n.effectiveFilterWidth,v=c-1-n.padInfo.left,y=l-1-n.padInfo.top,m=e.buffer(r.shape,"float32"),g=this.bufferSync(t),S=0;S<n.batchSize;++S)for(var I=0;I<n.inChannels;++I)for(var b=0;b<n.inHeight;++b)for(var k=0;k<n.inWidth;++k){for(var M=b-y,x=k-v,F=0,w=0;w<l;w+=u){var A=(M+w)/h;if(!(A<0||A>=n.outHeight||Math.floor(A)!==A))for(var z=0;z<c;z+=f){var T=(x+z)/p;if(!(T<0||T>=n.outWidth||Math.floor(T)!==T)){var D=l*c-1-s.get(S,A,T,I)===w*c+z?1:0;if(0!==D)F+=g.get(S,A,T,I)*D}}}m.set(F,S,b,k,I)}return m.toTensor()},v.prototype.avgPoolBackprop=function(t,r,a){i([t,r],"avgPoolBackprop");for(var n=a.strideHeight,o=a.strideWidth,s=a.filterHeight,d=a.filterWidth,h=a.dilationHeight,p=a.dilationWidth,u=a.effectiveFilterHeight,f=a.effectiveFilterWidth,l=f-1-a.padInfo.left,c=u-1-a.padInfo.top,v=e.buffer(r.shape,"float32"),y=1/(s*d),m=this.bufferSync(t),g=0;g<a.batchSize;++g)for(var S=0;S<a.inChannels;++S)for(var I=0;I<a.inHeight;++I)for(var b=0;b<a.inWidth;++b){for(var k=I-c,M=b-l,x=0,F=0;F<u;F+=h){var w=(k+F)/n;if(!(w<0||w>=a.outHeight||Math.floor(w)!==w))for(var A=0;A<f;A+=p){var z=(M+A)/o;if(!(z<0||z>=a.outWidth||Math.floor(z)!==z))x+=m.get(g,w,z,S)}}v.set(x*y,g,I,b,S)}return v.toTensor()},v.prototype.pool3d=function(t,r,a){i(t,"pool3d");for(var n=r.strideDepth,o=r.strideHeight,s=r.strideWidth,d=r.dilationDepth,h=r.dilationHeight,p=r.dilationWidth,u=r.effectiveFilterDepth,f=r.effectiveFilterHeight,l=r.effectiveFilterWidth,c=r.padInfo.front,v=r.padInfo.top,y=r.padInfo.left,m="max"===a?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,g=this.readSync(t.dataId),S=e.buffer(r.outShape,t.dtype),I=S.values,b=r.outShape[1]*r.outShape[2]*r.outShape[3]*r.outShape[4],k=r.outShape[2]*r.outShape[3]*r.outShape[4],M=r.outShape[3]*r.outShape[4],x=r.outShape[4],F=0;F<r.batchSize;++F)for(var w=F*b,A=F*t.strides[0],z=0;z<r.inChannels;++z)for(var T=0;T<r.outDepth;++T){for(var D=T*n-c,W=D;W<0;)W+=d;for(var _=Math.min(r.inDepth,u+D),O=w+T*k,H=0;H<r.outHeight;++H){for(var N=H*o-v,B=N;B<0;)B+=h;for(var C=Math.min(r.inHeight,f+N),E=O+H*M,P=0;P<r.outWidth;++P){for(var R=P*s-y,q=R;q<0;)q+=p;for(var L=Math.min(r.inWidth,l+R),U=E+P*x,j=m,G=0,V=0,Y=W;Y<_;Y+=d){for(var K=A+Y*t.strides[1],J=B;J<C;J+=h){for(var Q=K+J*t.strides[2],X=q;X<L;X+=p){var Z=g[Q+X*t.strides[3]+z];if("max"===a&&Z>j?j=Z:"avg"===a&&(G+=Z,V++),isNaN(j))break}if(isNaN(j))break}if(isNaN(j))break}I[U+z]="avg"===a?G/V:j}}}return S.toTensor()},v.prototype.avgPool3d=function(t,e){return i(t,"avgPool3d"),this.pool3d(t,e,"avg").toFloat()},v.prototype.avgPool3dBackprop=function(t,r,a){i([t,r],"avgPool3dBackprop");for(var n=a.strideDepth,o=a.strideHeight,s=a.strideWidth,d=a.filterDepth,h=a.filterHeight,p=a.filterWidth,u=a.dilationDepth,f=a.dilationHeight,l=a.dilationWidth,c=a.effectiveFilterDepth,v=a.effectiveFilterHeight,y=a.effectiveFilterWidth,m=c-1-a.padInfo.front,g=y-1-a.padInfo.left,S=v-1-a.padInfo.top,I=e.buffer(r.shape,"float32"),b=1/(d*h*p),k=this.bufferSync(t),M=0;M<a.batchSize;++M)for(var x=0;x<a.inChannels;++x)for(var F=0;F<a.inDepth;++F)for(var w=0;w<a.inHeight;++w)for(var A=0;A<a.inWidth;++A){for(var z=F-m,T=w-S,D=A-g,W=0,_=0;_<c;_+=u){var O=(z+_)/n;if(!(O<0||O>=a.outDepth||Math.floor(O)!==O))for(var H=0;H<v;H+=f){var N=(T+H)/o;if(!(N<0||N>=a.outHeight||Math.floor(N)!==N))for(var B=0;B<y;B+=l){var C=(D+B)/s;if(!(C<0||C>=a.outWidth||Math.floor(C)!==C))W+=k.get(M,O,N,C,x)}}}I.set(W*b,M,F,w,A,x)}return I.toTensor()},v.prototype.maxPool3d=function(t,e){return i(t,"maxPool3d"),this.pool3d(t,e,"max").toFloat()},v.prototype.maxPool3dPositions=function(t,r){for(var a=e.buffer(r.outShape,"int32"),n=r.strideDepth,o=r.strideHeight,i=r.strideWidth,s=r.dilationDepth,d=r.dilationHeight,h=r.dilationWidth,p=r.effectiveFilterDepth,u=r.effectiveFilterHeight,f=r.effectiveFilterWidth,l=r.padInfo.front,c=r.padInfo.top,v=r.padInfo.left,y=this.bufferSync(t),m=0;m<r.batchSize;++m)for(var g=0;g<r.inChannels;++g)for(var S=0;S<r.outDepth;++S){for(var I=S*n-l,b=I;b<0;)b+=s;for(var k=Math.min(r.inDepth,p+I),M=0;M<r.outHeight;++M){for(var x=M*o-c,F=x;F<0;)F+=d;for(var w=Math.min(r.inHeight,u+x),A=0;A<r.outWidth;++A){for(var z=A*i-v,T=z;T<0;)T+=h;for(var D=Math.min(r.inWidth,f+z),W=Number.NEGATIVE_INFINITY,_=-1,O=b;O<k;O+=s)for(var H=O-I,N=F;N<w;N+=d)for(var B=N-x,C=T;C<D;C+=h){var E=C-z,P=y.get(m,O,N,C,g);P>=W&&(W=P,_=H*u*f+B*u+E)}a.set(_,m,S,M,A,g)}}}return a.toTensor()},v.prototype.maxPool3dBackprop=function(t,r,a,n){i([r,a],"maxPool3dBackprop");for(var o=this.maxPool3dPositions(r,n),s=n.strideDepth,d=n.strideHeight,h=n.strideWidth,p=n.dilationDepth,u=n.dilationHeight,f=n.dilationWidth,l=n.effectiveFilterDepth,c=n.effectiveFilterHeight,v=n.effectiveFilterWidth,y=l-1-n.padInfo.front,m=v-1-n.padInfo.left,g=c-1-n.padInfo.top,S=e.buffer(r.shape,"float32"),I=this.bufferSync(o),b=this.bufferSync(t),k=0;k<n.batchSize;++k)for(var M=0;M<n.inChannels;++M)for(var x=0;x<n.inDepth;++x)for(var F=0;F<n.inHeight;++F)for(var w=0;w<n.inWidth;++w){for(var A=x-y,z=F-g,T=w-m,D=0,W=0;W<l;W+=p){var _=(A+W)/s;if(!(_<0||_>=n.outDepth||Math.floor(_)!==_))for(var O=0;O<c;O+=u){var H=(z+O)/d;if(!(H<0||H>=n.outHeight||Math.floor(H)!==H))for(var N=0;N<v;N+=f){var B=(T+N)/h;if(!(B<0||B>=n.outWidth||Math.floor(B)!==B)){var C=l*c*v-1-I.get(k,_,H,B,M)===W*c*v+O*v+N?1:0;if(0!==C)D+=b.get(k,_,H,B,M)*C}}}}S.set(D,k,x,F,w,M)}return S.toTensor()},v.prototype.cast=function(t,r){return e.backend_util.castTensor(t,r,this)},v.prototype.reshape=function(t,r){return e.backend_util.reshapeTensor(t,r)},v.prototype.avgPool=function(t,e){return i(t,"avgPool"),i(t,"maxPool"),s(this.readSync(t.dataId),t.shape,t.dtype,t.strides,e,"avg").toTensor().toFloat()},v.prototype.resizeBilinear=function(t,r,a,n){i(t,"resizeBilinear");for(var o=t.shape,s=o[0],d=o[1],h=o[2],p=o[3],u=this.readSync(t.dataId),f=new Float32Array(e.util.sizeFromShape([s,r,a,p])),l=[n&&r>1?d-1:d,n&&a>1?h-1:h],c=[n&&r>1?r-1:r,n&&a>1?a-1:a],v=0,y=l[0]/c[0],m=l[1]/c[1],g=0;g<s;g++)for(var S=0;S<r;S++)for(var I=y*S,b=Math.floor(I),k=I-b,M=Math.min(d-1,Math.ceil(I)),x=g*t.strides[0]+b*t.strides[1],F=g*t.strides[0]+M*t.strides[1],w=0;w<a;w++)for(var A=m*w,z=Math.floor(A),T=A-z,D=Math.min(h-1,Math.ceil(A)),W=x+z*t.strides[2],_=F+z*t.strides[2],O=x+D*t.strides[2],H=F+D*t.strides[2],N=0;N<p;N++){var B=u[W+N],C=u[_+N],E=B+(u[O+N]-B)*T,P=E+(C+(u[H+N]-C)*T-E)*k;f[v++]=P}return e.tensor(f,[s,r,a,p])},v.prototype.resizeBilinearBackprop=function(t,r,a){i([t,r],"resizeBilinearBackprop");for(var n=r.shape,o=n[0],s=n[1],d=n[2],h=n[3],p=t.shape,u=p[1],f=p[2],l=new Float32Array(o*s*d*h),c=[a&&u>1?s-1:s,a&&f>1?d-1:d],v=[a&&u>1?u-1:u,a&&f>1?f-1:f],y=c[0]/v[0],m=c[1]/v[1],g=this.readSync(t.dataId),S=0,I=0;I<o;I++)for(var b=I*r.strides[0],k=0;k<u;k++)for(var M=k*y,x=Math.floor(M),F=Math.min(Math.ceil(M),s-1),w=b+x*r.strides[1],A=b+F*r.strides[1],z=M-x,T=1-z,D=0;D<f;D++)for(var W=D*m,_=Math.floor(W),O=Math.min(Math.ceil(W),d-1),H=W-_,N=1-H,B=w+_*r.strides[2],C=w+O*r.strides[2],E=A+_*r.strides[2],P=A+O*r.strides[2],R=T*N,q=T*H,L=z*N,U=z*H,j=0;j<h;j++){var G=g[S++];l[B+j]+=G*R,l[C+j]+=G*q,l[E+j]+=G*L,l[P+j]+=G*U}return e.tensor4d(l,[o,d,s,h],r.dtype)},v.prototype.resizeNearestNeighbor=function(t,r,a,n){i(t,"resizeNearestNeighbor");for(var o=t.shape,s=o[0],d=o[1],h=o[2],p=o[3],u=this.readSync(t.dataId),f=new Float32Array(s*r*a*p),l=[n&&r>1?d-1:d,n&&a>1?h-1:h],c=[n&&r>1?r-1:r,n&&a>1?a-1:a],v=l[0]/c[0],y=l[1]/c[1],m=0,g=0;g<s;g++)for(var S=g*t.strides[0],I=0;I<r;I++)for(var b=v*I,k=S+Math.min(d-1,n?Math.round(b):Math.floor(b))*t.strides[1],M=0;M<a;M++)for(var x=y*M,F=k+Math.min(h-1,n?Math.round(x):Math.floor(x))*t.strides[2],w=0;w<p;w++){var A=u[F+w];f[m++]=A}return e.tensor(f,[s,r,a,p],t.dtype)},v.prototype.resizeNearestNeighborBackprop=function(t,r,a){i([t,r],"resizeNearestNeighborBackprop");for(var n=r.shape,o=n[0],s=n[1],d=n[2],h=n[3],p=t.shape,u=p[1],f=p[2],l=new Float32Array(o*s*d*h),c=this.readSync(t.dataId),v=[a&&u>1?s-1:s,a&&f>1?d-1:d],y=[a&&u>1?u-1:u,a&&f>1?f-1:f],m=v[0]/y[0],g=v[1]/y[1],S=1/m,I=1/g,b=2*Math.ceil(S)+2,k=2*Math.ceil(I)+2,M=0;M<o;M++)for(var x=M*r.strides[0],F=0;F<s;F++)for(var w=x+F*r.strides[1],A=Math.floor(F*S),z=Math.floor(A-b/2),T=0;T<d;T++)for(var D=w+T*r.strides[2],W=Math.floor(T*I),_=Math.floor(W-k/2),O=0;O<h;O++){for(var H=0,N=0;N<b;N++){var B=N+z;if(!(B<0||B>=u)){var C=x+B*t.strides[1],E=B*m;if(F===Math.min(s-1,a?Math.round(E):Math.floor(E)))for(var P=0;P<k;P++){var R=P+_;if(!(R<0||R>=f)){var q=C+R*t.strides[2],L=R*g;T===Math.min(d-1,a?Math.round(L):Math.floor(L))&&(H+=c[q+O])}}}}l[D+O]=H}return e.tensor4d(l,r.shape,r.dtype)},v.prototype.batchNormalization=function(t,r,a,n,o,s){i([t,r,a,o,s],"batchNorm");for(var d=this.readSync(t.dataId),h=this.readSync(r.dataId),p=this.readSync(a.dataId),u=o?this.readSync(o.dataId):new Float32Array([1]),f=s?this.readSync(s.dataId):new Float32Array([0]),l=new Float32Array(d.length),c=f.length,v=u.length,y=p.length,m=h.length,g=0,S=0,I=0,b=0,k=0;k<d.length;++k)l[k]=f[g++]+(d[k]-h[S++])*u[I++]/Math.sqrt(p[b++]+n),g>=c&&(g=0),S>=m&&(S=0),I>=v&&(I=0),b>=y&&(b=0);return e.tensor4d(l,t.shape)},v.prototype.localResponseNormalization4D=function(t,r,a,n,o){i(t,"localResponseNormalization4D");var s=t.shape[3],d=s-1,h=this.readSync(t.dataId),p=t.size,u=new Float32Array(p);function f(t){for(var e=t%s,a=t-e+Math.max(0,e-r),n=t-e+Math.min(e+r,d),o=0;a<=n;a++){var i=h[a];o+=i*i}return o}for(var l=0;l<p;l++){var c=f(l),v=h[l]*Math.pow(a+n*c,-o);u[l]=v}return e.tensor4d(u,t.shape)},v.prototype.LRNGrad=function(t,r,a,n,o,s,d){i(t,"LRNGrad");for(var h=t.shape[3],p=this.readSync(t.dataId),u=this.readSync(r.dataId),f=this.readSync(a.dataId),l=new Float32Array(t.size),c=t.size,v=0;v<c;v++){for(var y=v%h,m=v-y+Math.max(0,y-n),g=v-y+Math.min(h,y+n+1),S=0,I=m;I<g;I++)S+=Math.pow(u[I],2);S=s*S+o;for(I=m;I<g;I++){var b=-2*s*d*u[I]*f[v]/S;v===I&&(b+=Math.pow(S,-d)),b*=p[v],l[I]+=b}}return e.tensor4d(l,t.shape)},v.prototype.multinomial=function(t,a,n,o){i(t,"multinomial");for(var s=a?t:e.softmax(t),d=s.shape[0],h=s.shape[1],p=e.zeros([d,n],"int32"),u=this.readSync(p.dataId),f=this.readSync(s.dataId),l=0;l<d;++l){var c=l*h,v=new Float32Array(h-1);v[0]=f[c];for(var y=1;y<v.length;++y)v[y]=v[y-1]+f[c+y];for(var m=r.alea(o.toString()),g=l*n,S=0;S<n;++S){var I=m();u[g+S]=v.length;for(var b=0;b<v.length;b++)if(I<v[b]){u[g+S]=b;break}}}return p},v.prototype.oneHot=function(t,r,a,n){i(t,"oneHot");var o=new Float32Array(t.size*r);o.fill(n);for(var s=this.readSync(t.dataId),d=0;d<t.size;++d)s[d]>=0&&s[d]<r&&(o[d*r+s[d]]=a);return e.tensor2d(o,[t.size,r],"int32")},v.prototype.nonMaxSuppression=function(t,e,r,a,n){i(t,"nonMaxSuppression");var o=this.readSync(t.dataId),s=this.readSync(e.dataId);return h(o,s,r,a,n)},v.prototype.fft=function(t){return this.fftBatch(t,!1)},v.prototype.ifft=function(t){return this.fftBatch(t,!0)},v.prototype.fftBatch=function(t,r){for(var a=t.shape[0],n=t.shape[1],o=e.buffer(t.shape,"float32"),i=e.buffer(t.shape,"float32"),s=e.real(t).as2D(a,n),d=e.imag(t).as2D(a,n),h=0;h<a;h++)for(var p=s.slice([h,0],[1,n]),u=d.slice([h,0],[1,n]),f=e.complex(p,u),l=this.readSync(this.fftImpl(f,r).dataId),c=0;c<n;c++){var v=e.backend_util.getComplexWithIndex(l,c);o.values[h*n+c]=v.real,i.values[h*n+c]=v.imag}return e.complex(o.toTensor(),i.toTensor()).as2D(a,n)},v.prototype.fftImpl=function(t,r){var a=t.as1D(),n=a.size;if(this.isExponentOf2(n)){var o=this.fftRadix2(a,n,r).as2D(t.shape[0],t.shape[1]);return r&&(o=e.complex(e.real(o).div(e.scalar(n)),e.imag(o).div(e.scalar(n)))),o}var i=this.readSync(t.dataId),s=this.fourierTransformByMatmul(i,n,r),d=e.backend_util.splitRealAndImagArrays(s);return e.complex(d.real,d.imag).as2D(t.shape[0],t.shape[1])},v.prototype.isExponentOf2=function(t){return 0==(t&t-1)},v.prototype.fftRadix2=function(t,r,a){if(1===r)return t;var n=this.readSync(t.dataId),o=r/2,i=e.backend_util.complexWithEvenIndex(n),s=e.complex(i.real,i.imag).as1D(),d=e.backend_util.complexWithOddIndex(n),h=e.complex(d.real,d.imag).as1D();s=this.fftRadix2(s,o,a),h=this.fftRadix2(h,o,a);var p=e.backend_util.exponents(r,a),u=e.complex(p.real,p.imag).mul(h),f=s.add(u),l=s.sub(u),c=e.real(f).concat(e.real(l)),v=e.imag(f).concat(e.imag(l));return e.complex(c,v).as1D()},v.prototype.fourierTransformByMatmul=function(t,r,a){for(var n=new Float32Array(2*r),o=0;o<r;o++){for(var i=0,s=0,d=0;d<r;d++){var h=e.backend_util.exponent(o*d,r,a),p=e.backend_util.getComplexWithIndex(t,d);i+=p.real*h.real-p.imag*h.imag,s+=p.real*h.imag+p.imag*h.real}a&&(i/=r,s/=r),e.backend_util.assignToTypedArray(n,i,s,o)}return n},v.prototype.depthToSpace=function(t,r,a){e.util.assert("NHWC"===a,(function(){return"Only NHWC dataFormat supported on CPU for depthToSpace. Got "+a})),e.util.assert(r>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+r}));for(var n=t.shape[0],o=t.shape[1],i=t.shape[2],s=t.shape[3],d=o*r,h=i*r,p=s/(r*r),u=this.readSync(t.dataId),f=new Float32Array(n*d*h*p),l=0,c=0;c<n;++c)for(var v=0;v<d;++v)for(var y=Math.floor(v/r),m=v%r,g=0;g<h;++g)for(var S=Math.floor(g/r),I=(m*r+g%r)*p,b=0;b<p;++b){var k=b+I+s*(S+i*(y+o*c));f[l++]=u[k]}return e.tensor4d(f,[n,d,h,p])},v.prototype.broadcastedBinaryOp=function(t,r,a,n){var o=e.backend_util.assertAndGetBroadcastShape(t.shape,r.shape),i=e.buffer(o,a),s=this.readSync(t.dataId),d=this.readSync(r.dataId),h=e.backend_util.getBroadcastDims(t.shape,o),p=e.backend_util.getBroadcastDims(r.shape,o),u=i.values;if(h.length+p.length===0)for(var f=0;f<u.length;++f)u[f]=n(s[f%s.length],d[f%d.length]);else{var l=this.bufferSync(t),c=this.bufferSync(r),v=function(e){var a=i.indexToLoc(e),o=a.slice(-t.rank);h.forEach((function(t){return o[t]=0}));var f=l.locToIndex(o),v=a.slice(-r.rank);p.forEach((function(t){return v[t]=0}));var y=c.locToIndex(v);u[e]=n(s[f],d[y])};for(f=0;f<u.length;++f)v(f)}return i.toTensor()},v.prototype.broadcastedBinaryComplexOp=function(t,r,a){var n=e.backend_util.assertAndGetBroadcastShape(t.shape,r.shape),o=e.buffer(n,"float32"),i=e.buffer(n,"float32"),s=this.readSync(t.dataId),d=this.readSync(r.dataId),h=e.backend_util.getBroadcastDims(t.shape,n),p=e.backend_util.getBroadcastDims(r.shape,n),u=o.values,f=i.values;if(h.length+p.length===0)for(var l=0;l<u.length;l++){var c=l%s.length,v=l%d.length,y=a(s[2*c],s[2*c+1],d[2*v],d[2*v+1]);u[l]=y.real,f[l]=y.imag}else{var m=this.bufferSync(this.data.get(t.dataId).complexTensors.real),g=this.bufferSync(this.data.get(r.dataId).complexTensors.real),S=function(e){var n=o.indexToLoc(e),i=n.slice(-t.rank);h.forEach((function(t){return i[t]=0}));var l=m.locToIndex(i),c=n.slice(-r.rank);p.forEach((function(t){return c[t]=0}));var v=g.locToIndex(c),y=a(s[2*l],s[2*l+1],d[2*v],d[2*v+1]);u[e]=y.real,f[e]=y.imag};for(l=0;l<u.length;l++)S(l)}return this.complex(o.toTensor(),i.toTensor())},v.prototype.split=function(t,e,r){return p(t,e,r)},v.prototype.dispose=function(){},v.prototype.floatPrecision=function(){return 32},v.prototype.epsilon=function(){return t.prototype.epsilon.call(this)},v.prototype.cropAndResize=function(t,r,a,n,o,i){for(var s=t.shape,d=s[0],h=s[1],p=s[2],u=s[3],f=r.shape[0],l=n[0],c=n[1],v=e.buffer([f,l,c,u],"float32"),y=this.readSync(r.dataId),m=this.readSync(a.dataId),g=this.readSync(t.dataId),S=t.strides,I=v.strides,b=0;b<f;b++){var k=4*b,M=y[k],x=y[k+1],F=y[k+2],w=y[k+3],A=m[b];if(!(A>=d))for(var z=l>1?(F-M)*(h-1)/(l-1):0,T=c>1?(w-x)*(p-1)/(c-1):0,D=0;D<l;D++){var W=l>1?M*(h-1)+D*z:.5*(M+F)*(h-1);if(W<0||W>h-1)for(var _=0;_<c;_++)for(var O=0;O<u;O++){var H=O+_*I[2]+D*I[1]+b*I[0];v.values[H]=i}else if("bilinear"===o){var N=Math.floor(W),B=Math.ceil(W),C=W-N;for(_=0;_<c;_++){if((V=c>1?x*(p-1)+_*T:.5*(x+w)*(p-1))<0||V>p-1)for(O=0;O<u;O++){H=O+_*I[2]+D*I[1]+b*I[0];v.values[H]=i}else{var E=Math.floor(V),P=Math.ceil(V),R=V-E;for(O=0;O<u;O++){var q=g[H=O+E*S[2]+N*S[1]+A*S[0]],L=g[H=O+P*S[2]+N*S[1]+A*S[0]],U=g[H=O+E*S[2]+B*S[1]+A*S[0]],j=q+(L-q)*R,G=U+(g[H=O+P*S[2]+B*S[1]+A*S[0]]-U)*R;H=O+_*I[2]+D*I[1]+b*I[0],v.values[H]=j+(G-j)*C}}}}else for(_=0;_<c;++_){var V;if((V=c>1?x*(p-1)+_*T:.5*(x+w)*(p-1))<0||V>p-1)for(O=0;O<u;O++){H=O+_*I[2]+D*I[1]+b*I[0];v.values[H]=i}else{var Y=Math.round(V),K=Math.round(W);for(O=0;O<u;O++){var J=O+Y*S[2]+K*S[1]+A*S[0],Q=O+_*I[2]+D*I[1]+b*I[0];v.values[Q]=g[J]}}}}}return v.toTensor()},v.prototype.sparseToDense=function(t,r,a,n){var o=e.backend_util.calculateShapes(r,t,a),i=o.sliceRank,s=o.numUpdates,d=o.sliceSize,h=o.strides,p=o.outputSize;return this.scatter(t,r,a,p,d,s,i,h,n,!1)},v.prototype.gatherND=function(t,r){var a=r.shape,n=a[a.length-1],o=e.backend_util.prepareAndValidate(t,r),i=o[0],s=o[1],d=o[2],h=o[3];if(0===s)return e.tensor([],i,t.dtype);for(var p=new e.TensorBuffer([s,d],t.dtype),u=this.readSync(r.dataId),f=this.readSync(t.dataId),l=0;l<s;l++){for(var c=[],v=0,y=0;y<n;y++){var m=u[l*n+y];v+=m*h[y],c.push(m)}if(v<0||v>=t.size/d)throw new Error("Invalid indices: "+c+" does not index into "+t.shape);for(var g=0;g<d;g++)p.values[l*d+g]=f[v*d+g]}return p.toTensor().reshape(i)},v.prototype.scatterND=function(t,r,a){var n=e.backend_util.calculateShapes(r,t,a),o=n.sliceRank,i=n.numUpdates,s=n.sliceSize,d=n.strides,h=n.outputSize,p=e.scalar(0);return this.scatter(t,r,a,h,s,i,o,d,p,!0)},v.prototype.fill=function(t,r,a){a=a||e.util.inferDtype(r);var n=e.util.getArrayFromDType(a,e.util.sizeFromShape(t));return n.fill(r),e.engine().makeTensor(n,t,a,this)},v.prototype.onesLike=function(t){if("string"===t.dtype)throw new Error("onesLike is not supported for string tensors");return this.fill(t.shape,1,t.dtype)},v.prototype.zerosLike=function(t){var r=e.util.getArrayFromDType(t.dtype,e.util.sizeFromShape(t.shape));return this.makeOutput(r,t.shape,t.dtype)},v.prototype.linspace=function(t,r,a){return e.backend_util.linspaceImpl(t,r,a)},v.prototype.scatter=function(t,r,a,n,o,i,s,d,h,p){var u=[n/o,o],f=this.readSync(t.dataId),l=this.readSync(r.dataId);if(0===n)return e.tensor([],a,r.dtype);var c=new e.TensorBuffer(u,r.dtype);c.values.fill(this.readSync(h.dataId)[0]);for(var v=0;v<i;v++){for(var y=[],m=0,g=0;g<s;g++){var S=f[v*s+g];y.push(S),m+=S*d[g]}if(m<0||m>=n/o)throw new Error("Invalid indices: "+y+" does not index into "+a);for(var I=0;I<o;I++)p?c.values[m*o+I]+=l[v*o+I]:c.values[m*o+I]=0===r.rank?l[0]:l[v*o+I]}return c.toTensor().reshape(a)},v}(e.KernelBackend);function y(t,e){return{kernelName:t,backendName:"cpu",kernelFunc:function(r){var a=r.inputs,n=r.backend,o=a,s=o.a,d=o.b,h=n;i([s,d],t);var p=h.data.get(s.dataId).values,u=h.data.get(d.dataId).values,f=e(s.shape,d.shape,p,u,s.dtype),l=f[0],c=f[1];return{dataId:h.write(l,c,s.dtype),shape:c,dtype:s.dtype}}}}function m(t){return function(r,a,n,o,i){var s=e.backend_util.assertAndGetBroadcastShape(r,a),d=s.length,h=e.util.computeStrides(s),p=e.util.sizeFromShape(s),u=e.util.getTypedArrayFromDType(i,p),f=r.length,l=a.length,c=e.util.computeStrides(r),v=e.util.computeStrides(a),y=e.backend_util.getBroadcastDims(r,s),m=e.backend_util.getBroadcastDims(a,s);if(y.length+m.length===0)for(var g=0;g<u.length;++g)u[g]=t(n[g%n.length],o[g%o.length]);else{var S=function(r){var a=e.util.indexToLoc(r,d,h),i=a.slice(-f);y.forEach((function(t){return i[t]=0}));var s=e.util.locToIndex(i,f,c),p=a.slice(-l);m.forEach((function(t){return p[t]=0}));var g=e.util.locToIndex(p,l,v);u[r]=t(n[s],o[g])};for(g=0;g<u.length;++g)S(g)}return[u,s]}}var g=m((function(t,e){return t/e})),S=y(e.Div,g);var I={kernelName:e.MaxPoolWithArgmax,backendName:"cpu",kernelFunc:function(t){var r=t.inputs,a=t.attrs,n=t.backend,o=r.x,h=a,p=h.filterSize,u=h.strides,f=h.pad,l=h.includeBatchInIndex,c=n;i(o,"MaxPoolWithArgmax");var v=c.data.get(o.dataId).values,y=e.backend_util.computePool2DInfo(o.shape,p,u,[1,1],f),m=function(t,r,a,n,o){var i=s(t,0,a,e.util.computeStrides(r),o,"max"),h=d(t,r,a,o,!0,n);return[i.values,h.values]}(v,o.shape,o.dtype,l,y),g=m[0],S=m[1],I=c.write(g,y.outShape,o.dtype),b=c.write(S,y.outShape,o.dtype);return[{dataId:I,shape:y.outShape,dtype:o.dtype},{dataId:b,shape:y.outShape,dtype:"int32"}]}},b=e.kernel_impls.nonMaxSuppressionV5,k={kernelName:e.NonMaxSuppressionV5,backendName:"cpu",kernelFunc:function(t){var e=t.inputs,r=t.backend,a=t.attrs,n=e,o=n.boxes,s=n.scores,d=a,h=d.maxOutputSize,p=d.iouThreshold,u=d.scoreThreshold,f=d.softNmsSigma,l=r;i(o,"NonMaxSuppressionWithScore");var c=l.data.get(o.dataId).values,v=l.data.get(s.dataId).values,y=b(c,v,h,p,u,f);return[y.selectedIndices,y.selectedScores]}},M={kernelName:e.Square,backendName:"cpu",kernelFunc:function(t){var e=t.inputs,r=t.backend,a=e.x,n=r;i(a,"square");for(var o=n.data.get(a.dataId).values,s=new Float32Array(o.length),d=0;d<o.length;++d){var h=o[d];s[d]=h*h}return{dataId:n.write(s,a.shape,a.dtype),shape:a.shape,dtype:a.dtype}}},x=m((function(t,e){var r=t-e;return r*r}));for(var F=0,w=[k,M,y(e.SquaredDifference,x),S,{kernelName:e.Transpose,backendName:"cpu",kernelFunc:function(t){var r=t.inputs,a=t.attrs,n=t.backend,o=r.x,s=a.perm,d=n;i(o,"transpose");for(var h=o.shape.length,p=new Array(h),u=0;u<p.length;u++)p[u]=o.shape[s[u]];var f=function(t,r,a,n,o){for(var i=e.util.sizeFromShape(r),s=r.length,d=e.util.computeStrides(r),h=e.util.computeStrides(o),p=e.util.getTypedArrayFromDType(a,e.util.sizeFromShape(o)),u=0;u<i;++u){for(var f=e.util.indexToLoc(u,s,d),l=new Array(f.length),c=0;c<l.length;c++)l[c]=f[n[c]];p[e.util.locToIndex(l,s,h)]=t[u]}return p}(d.data.get(o.dataId).values,o.shape,o.dtype,s,p);return{dataId:d.write(f,p,o.dtype),shape:p,dtype:o.dtype}}},I];F<w.length;F++){var A=w[F];e.registerKernel(A)}e.registerBackend("cpu",(function(){return new v}),1),t.MathBackendCPU=v,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-cpu.min.js.map
